# # sample index page with internationalization (T)
def index():
    redirect(URL(r=request,f='listes',args=['all']))
    return dict()
    
def aide():
    return dict(message="ici une page d'aide... pour le moment Version au: 27 mai 2009 ")
    
def liens():
    liens_Demexp={'Forum Demexp':'http://demexp.org/phpbb/'}
    liens_Prog={'Site web2py ':'http://www.web2py.com/',
                'Site Python ':'http://www.python.org/'}
                
    liens_Deleg={}   #à remplir avec base de donnée          
    return dict(liens_Demexp=liens_Demexp,liens_Prog=liens_Prog,liens_Deleg=liens_Deleg)
                
def result_schulze():
    ### Procède au dépouillement du vote selon la méthode de Schulze
    resultat={}
    Q_id=request.args[0]
    la_Q=db(db.Questions.id==Q_id).select()[0]
    resultat=str_to_dict(la_Q.resultat)
    
    #Récupération des réponses et leurs index 
    les_Reponses=[]
    num_reponses=[]
    for r in db(db.Reponses.Q_id==Q_id).select(db.Reponses.ALL):
        les_Reponses.append(r.titre)
        num_reponses.append(str(r.id))
        
    resultat=traduit_result(resultat,num_reponses)
    num=[str(elem) for elem in range(1,len(num_reponses)+1)]
    
    PD={}
    for i in num:
        for j in num:
            if i != j:
                ij=i+'>'+j
                ji=j+'>'+i
                PD[ij]=resultat.get(ij,0)-resultat.get(ji,0)
                
    for i in num:
        for j in num:
            if i != j:
                for k in num:
                    if i != k and j != k:
                        jk=j+'>'+k
                        ji=j+'>'+i
                        ik=i+'>'+k
                        PD[jk]=max(PD[jk],min(PD[ji],PD[ik]))
    winner=[]
                        
    for i in num:
        winner.append(i)
    for i in num:
        for j in num:
            if i != j:
                ji=j+'>'+i
                ij=i+'>'+j
                if PD[ji] > PD[ij] and i in winner:
                    del(winner[winner.index(i)])
                  
    return dict(Q=la_Q.description,R=les_Reponses,resultat=resultat,winner=winner)
                    
    
def traduit_result(resultat,num_reponses):
    #traduit des résultats de type {'23>25':12,..} en {'1>3':12,..}
    new_resultat={}
    for clef in resultat:        
        R=clef.split('>')
        new_clef=str(num_reponses.index(R[0])+1)+'>'+str(num_reponses.index(R[1])+1)
        new_resultat[new_clef]=resultat[clef]
    return new_resultat    
                
    
@auth.requires_login()
def vote():
    #si le vote n'est pas valide (bulletin créé en Question X et voté en Question Y..(avec plusieurs questions ouvertes))
    if request.args[0]!=session.q:
        session.flash="vote NON VALIDE ! vous devez voter dans la zone du dernier bulletin préparé"
        redirect(URL(r=request,f="listes"))

    la_Q=db(db.Questions.id==request.args[0]).select()[0]
    #si date de cloture dépassée 
    if la_Q.date_limite<request.now:
        session.flash="LA DATE DE CLOTURE POUR CETTE QUESTION EST DEPASEE...désolé,vous ne pouvez pas voter !"
        redirect(URL(r=request,f="listes"))

    #si le vote est valide    
    bulletin=''.join(session.v)
    old_vote=(db.Votes.U_id==auth.user.id)&(db.Votes.Q_id==request.args[0])
    
    #si ancien vote existant
    if len(db(old_vote).select())>0:
        for v in db(old_vote).select():          
            old_bulletin=v.Buletin                                          
            old_matchs=matching(request.args[0],old_bulletin,v.date_vote)
            
        db(old_vote).update(D_id='',
                            Buletin=bulletin,
                            date_vote=request.now)
                            
        matchs=matching(request.args[0],bulletin,request.now)
        update_resultat(request.args[0],matchs,old_matchs)
        session.flash="Votre vote a été mis à jour..."
    #si pas d'ancien vote    
    else:
        vote_id=db.Votes.insert(Q_id=request.args[0],
                                U_id=auth.user.id,D_id='',
                                Buletin=bulletin,
                                date_vote=request.now)
        ##la_Q=db(db.Questions.id==request.args[0]).select()[0] 
        matchs=matching(request.args[0],bulletin,request.now)                       
        db(db.Questions.id==request.args[0]).update(nbr_votes=la_Q.nbr_votes+1)
        update_resultat(request.args[0],matchs)
        
        session.flash="Votre vote a été enregistré..." 
    redirect(URL(r=request,f="listes"))
    return dict()
    
def str_to_dict(chaine):
    dico={}
    if chaine==None or chaine=='{}':
        return dico
    chaine=chaine.replace(' ','')
    chaine=chaine.replace('{','')
    chaine=chaine.replace('}','')
    chaine=chaine.replace("'",'')
    liste=chaine.split(',')
    for elem in liste:
        l_e=elem.split(':')
        dico[l_e[0]]=int(l_e[1])
    return dico
    
def update_resultat(Q_id,matchs,old_matchs=[]):
    resultat={}
    la_Q=db(db.Questions.id==Q_id).select()[0]
    resultat=str_to_dict(la_Q.resultat)
    old_resultat=resultat.copy()
    #on décrémente les anciens matchs
    for m in old_matchs:
        resultat[m]=resultat[m]-1
    #on incrémente les nouveaux matchs    
    for m in matchs:
        try:
            resultat[m]+=1
        except:
            resultat[m]=1
        
    db(db.Questions.id==Q_id).update(resultat=resultat)
    #session.flash="matchs... %s vers %s  ** resultat...%s  vers %s" %(old_matchs,matchs,old_resultat,resultat)
    
def matching(Q_id,bulletin,date_vote):
    matchs=[]
    liste_rns=[]
    #liste des réponses sélectionnées
    liste=bulletin.split('_')[1:]
    
    #liste des réponses non sélectionnées
    #prise en compte de la date pour les mises à jour (pour ne pas annuler un match sur question inexistante au temps du vote...)
    for j in  db(db.Reponses.Q_id==Q_id).select(db.Reponses.ALL):
        if str(j.id) not in liste and j.date_postee<=date_vote:
            liste_rns.append(str(j.id))
        
    liste_b=liste+liste_rns
    for r in liste:
        for r2 in liste_b[liste_b.index(r)+1:]:
            couple=r+'>'+r2
            matchs.append(couple)
    return matchs
    
@auth.requires_login()    
def new_Q():
    form=SQLFORM(db.Questions)
    if form.accepts(request.vars,session):
        session.flash="Nouvelle Question prise en compte.."
        redirect(URL(r=request,f="listes",args=['all']))
    return dict(form=form)
    
@auth.requires_login()
def new_R():
    db.Reponses.Q_id.default=request.args[0]
    form=SQLFORM(db.Reponses)
    if form.accepts(request.vars,session):
        session.flash="Nouvelle Réponse prise en compte.."
        redirect(URL(r=request,f="listes"))
    return dict(form=form)
    
@auth.requires_login()  #membership('Administrateurs')
def new_T():
    form=SQLFORM(db.Tags,fields=['titre'])
    if form.accepts(request.vars,session):
        session.flash="Nouveau Tag créé..."
        redirect(URL(r=request,f="listes"))
    return dict(form=form)

@auth.requires_login()
def add_T():
    message=''
    existe=0
    db.Tags_Questions.Q_id.default=request.args[0]
    form=SQLFORM(db.Tags_Questions)
    if form.accepts(request.vars,session):
        for Tnum in db(db.Tags_Questions.Q_id==request.args[0]).select(db.Tags_Questions.ALL):
            if str(Tnum.T_id)==form.vars.T_id:
                existe+=1
                if existe>1:
                    db(db.Tags_Questions.id==form.vars.id).delete()
                    message="existait déjà"
        session.flash="Nouveau Tag pris en compte...%s" %message
        redirect(URL(r=request,f="listes"))
    return dict(form=form)


    
def listes():
    if request.args:
        session.tag=request.args[0]
    if not session.aut:session.aut=('all','all') # (id,nom)
     
    if session.tag=='all':
        if session.aut[0]=='all':       
            questions=db(db.Questions.visibilite=='True').select(db.Questions.ALL)
        else:
            questions=db(db.Questions.auteur_id==session.aut[0]).select(db.Questions.ALL)
    else:
        if session.aut[0]=='all':       
            questions=db((db.Questions.visibilite=='True')
                        &(db.Tags_Questions.T_id==session.tag)
                        &(db.Tags_Questions.Q_id==db.Questions.id)).select(db.Questions.ALL)
        else:
            questions=db((db.Tags_Questions.T_id==session.tag)
                        &(db.Tags_Questions.Q_id==db.Questions.id)
                        &(db.Questions.auteur_id==session.aut[0])
                        &(db.Questions.visibilite=='True')).select(db.Questions.ALL)

    #Sélecteurs  ******************
    #de Tags
    dico_tags={'all':'all'}
    for t in db().select(db.Tags.ALL):
        dico_tags[str(t.id)]=t.titre
        
    liste_tags=[dico_tags[str(session.tag)]]
    for t in dico_tags.keys():
        if t != str(session.tag):
            liste_tags.append(dico_tags[t])
            
    #d'Auteurs
    dico_auts={'all':'all'}

    for q in db().select(db.Questions.ALL):
        if q.auteur_id not in dico_auts.keys():
            a=db(db.auth_user.id==q.auteur_id).select(db.auth_user.ALL)[0]
            auteur=a.first_name+' '+a.last_name
            dico_auts[q.auteur_id]=auteur
            
    liste_auts=[session.aut[1]]
    for a in dico_auts.keys():
        if a != session.aut[0] and dico_auts[a] not in liste_auts:
            liste_auts.append(dico_auts[a])
            

            
    form_choix_T=FORM(TABLE(TR("Sélection par: Tag ",SELECT(liste_tags,_name="Tag_choisi",requires=IS_IN_SET(liste_tags)),
                               "Auteur  ",SELECT(liste_auts,_name="Aut_choisi",requires=IS_IN_SET(liste_auts)),
                               "",     INPUT(_type="submit",_value="Envoi"))))
                               
    if form_choix_T.accepts(request.vars,session): 
        for t in dico_tags:
            if dico_tags[t]==form_choix_T.vars.Tag_choisi:
                tag_num=t
        for a in dico_auts:
            if dico_auts[a]==form_choix_T.vars.Aut_choisi:
                session.aut=(a,dico_auts[a])
        #tag_num=dico_tags[form_choix_T.vars.Tag_choisi]
        redirect(URL(r=request,f='listes',args=[tag_num]))
    return dict(questions=questions,form_choix_T=form_choix_T)

def data():
    #Utilisée pour la mise à jour de la liste des réponses sélectionnées (Ajax)
    if not session.m:session.m=[]
    if not session.v:session.v=[]
    for clef in request.vars:
        if 'champ' in clef:
            q=clef[5:clef.find('_')]
            if not session.q or session.q!=q:
                session.m=[]
                session.v=[]
                session.q=q
            r=clef[clef.find('_'):]
            if request.vars[clef] in session.m:
                idx=session.m.index(request.vars[clef])
                del(session.m[idx])
                del(session.v[idx])
            session.m.append(request.vars[clef])
            session.v.append(r)
    return TABLE(*[TR(v) for v in session.m]).xml()

@auth.requires_login()       
def deleg_vote():
    session.flash="!!  Non fonctionnel ...en cours de développement ... !!"
  
    dico_delegs={'aucun':'aucun'}
            
    group=db(db.auth_group.role=="Délégués").select(db.auth_group.ALL)[0]
    delegues_id=db(db.auth_membership.group_id==group.id).select(db.auth_membership.ALL)
    for d_id in delegues_id:
        if d_id.user_id not in dico_delegs.keys():
            d=db(db.auth_user.id==d_id.user_id).select(db.auth_user.ALL)[0]
            delegue=d.first_name+' '+d.last_name
            dico_delegs[d_id.user_id]=delegue
    liste_deleg=['aucun']
    for a in dico_delegs.keys():
        if dico_delegs[a] not in liste_deleg:
            liste_deleg.append(dico_delegs[a])
            
    form=FORM(TABLE(TR("Sélectionner un Délégué: ",SELECT(liste_deleg,_name="deleg_choisi",requires=IS_IN_SET(liste_deleg)),
                       "",     INPUT(_type="submit",_value="Envoi"))))
    if form.accepts(request.vars,session): 
        redirect(URL(r=request,f='listes'))#,args=[tag_num]))

    return dict(form=form)
    
def clear_target():
    #Nettoyage de la Zone "target" d'affichage des réponses sélectionnées
    session.m=[]
    session.v=[]
    
    return TABLE(*[TR(v) for v in session.m]).xml()
           
        
# # uncomment the following if you have defined "auth" and "crud" in models
def user(): return dict(form=auth())
# def data(): return dict(form=crud())
# def download(): return response.download(request,db)
# # tip: use @auth.requires_login, requires_membership, requires_permission