def result_popup():
    ### Procède au dépouillement du vote selon la méthodologie décrite dans la constitution Debian
    resultat={}
    liste_tuples=[]
    
    V_direct={}
    V_trans={}
    Q_id=request.args[0]
    la_Q=db(db.Questions.id==Q_id).select()[0]
    resultat=str_to_dict(la_Q.resultat)
    
    #Récupération des réponses et leurs index 
    les_Reponses=[]
    num_reponses=[]
    for r in db(db.Reponses.Q_id==Q_id).select(db.Reponses.ALL):
        les_Reponses.append(r.titre)
        num_reponses.append(str(r.id))
        
    resultat=traduit_result(resultat,num_reponses)
    
    #Recherche des victoires directes=> dictionnaire V_direct={Vainqueur:[liste des vaincus,...]}
    for clef in resultat:
        R=clef.split('>')
        A,B=R[0],R[1]
        anti_clef=B+'>'+A
        if resultat[clef]>resultat.get(anti_clef,0):
            #delta=resultat[clef]-resultat.get(anti_clef,0)
            if V_direct.has_key(A):
                V_direct[A].append(B)
            else:
                V_direct[A]=[B]
                
    #Recherche des victoires transitives                
    for V in V_direct:            #V=Vainqueur
        for P in V_direct[V]:     #P=Perdant(s) face à V
            #P est dans V_direct
            if V_direct.has_key(P):
                if V_trans.has_key(V):
                    V_trans[V].append(P)
                else:
                    V_trans[V]=[P]
                #Héritage des victoires du perdant 
                for H in V_direct[P]:
                    if V_direct.has_key(H) and H not in V_trans[V]:
                        V_trans[V].append(H)
                        
    #Construction de l'ensemble de Schwartz 
    schwartz=[]
    for V1 in V_trans:
        for V2 in V_trans:
            #V1 est dans l'ensemble si: bat transitivement V2 ou n'est pas batu par V2
            if V2 in V_trans[V1] or V1 not in V_trans[V2]:
                if V1 != V2:
                    schwartz.append(V1)
                           
    #if V_trans=={}:
    #    V_trans=V_direct    
                
    #for A in V_direct[:len(Vdirect)-1]:
    #    for B in V_direct[V_direct.index(A)+1:]:
    #        clef=A+'>'+B
    #        anti_clef=B+'>'+A
    #        if resultat[clef]>resultat[anti_clef]:        
    #for clef in resultat:
    #    t=(resultat[clef],clef)
    #    liste_tuples.append(t)
    #liste_tuples.sort()
    #liste_tuples.reverse()
        
    return dict(Q=la_Q.description,R=les_Reponses,resultat=resultat,V_direct=V_direct,V_trans=V_trans,schwartz=schwartz)