def go():
    import xmlrpclib
    url = "http://www.linux-france.org/cgi-bin/demexp-xmlrpc-test"
    s = xmlrpclib.ServerProxy(url)
    cookie = s.login("demo", "demo")
    
    max_qu_in_list =s.max_question_id(cookie)+1
    max_tags_in_list =int(s.max_tag_id(cookie))
    timestamps = s.get_timestamps(cookie)
    
    number_of_qu = 100

    full_question_list = get_full(cookie ,max_qu_in_list , number_of_qu ,s.question_info)
    full_question_tags = get_full(cookie ,max_qu_in_list , number_of_qu ,s.tag_set_of_question_group)
    full_tag_labels    = get_full(cookie ,max_tags_in_list,number_of_qu ,s.tag_info)

    full_question_list.sort(lambda x,y:cmp(x['q_id'],y['q_id']))
    full_question_tags.sort(lambda x,y:cmp(x['tag_set_qid'],y['tag_set_qid']))
    full_tag_labels.sort(lambda x,y:cmp(x['a_tag_id'],y['a_tag_id']))
    
    return dict(full_question_list=full_question_list)
    
def get_full(cookie,max_truc,number_of_qu,s_truc):    
    liste=[]
    n = int(max_truc / number_of_qu)
    n_rem = max_truc - n * number_of_qu + 1
    for k in range(n):
        liste[:] += s_truc(cookie,k*number_of_qu,number_of_qu)
    liste[:] += s_truc(cookie,n*number_of_qu,n_rem)
    return liste